#!/usr/bin/python3
# -*- coding: utf-8 -*-
################################################################################
#    Phoseg Copyright (C) 2012 Suizokukan
#    Contact: suizokukan at orange dot fr
#
#    This file is part of Phoseg.
#    Phoseg is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Phoseg is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Phoseg.  If not, see <http://www.gnu.org/licenses/>.
################################################################################
"""
        ❏Phoseg❏ : phoseg/phoseg.py
"""
from phoseg.phoneticsegment.phoneticsegment import PhoneticSegment as PhoneticSegment

if __name__ == "__main__":

    p = PhoneticSegment().init_from_SIPA_strings( "(j,a,l)" )
    print(p[0].onset[0][0].abstract_description)
    print(p[0].get_structure())

    import argparse

    parser = argparse.ArgumentParser(description="phoseg.py is a part of the 'Phoseg' project. Use this file to test the creation PhoneticSegment objects from (S)IPA strings.",
                                     epilog='épilogue',
                                     formatter_class=argparse.ArgumentDefaultsHelpFormatter
                                    )

    parser.add_argument('--SIPA',
                        action="store_true",
                        help="create a PhoneticSegment from a SIPA segment.",
                        default = False)

    parser.add_argument('--src',
                        type=str,
                        help="source string",
                        default = "-")

    args = parser.parse_args()

    # let's create a new PhoneticObject from a SIPA string :
    if args.SIPA:
        if args.src == "-":
            p = PhoneticSegment().init_from_SIPA_strings()
        else:
            p = PhoneticSegment().init_from_SIPA_strings( args.src )

        print(p)
