#!/usr/bin/python3
# -*- coding: utf-8 -*-
################################################################################
#    Phoseg Copyright (C) 2012 Suizokukan
#    Contact: suizokukan at orange dot fr
#
#    This file is part of Phoseg.
#    Phoseg is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Phoseg is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with Phoseg.  If not, see <http://www.gnu.org/licenses/>.
################################################################################
"""
        ❏Phoseg❏ phoseg/system/unicode_analysis.py : a function to analyse a (unicode) string

        * function return_an_analysis_of_a_string
"""

import unicodedata

#///////////////////////////////////////////////////////////////////////////////
def return_an_analysis_of_a_string(src,
                                   raw_number_only=False):
    """
        This function is debug-oriented and describes what's lie in the string
        <src>.

        * if <raw_number_only> == True:
                output = "XXXX YYYY ZZZZ ..."
    """

    res = ""

    for c in src:

        # normal case :
        try:

            if not raw_number_only:
                res = "".join(( res,
                                "(",
                                "NAME="+unicodedata.name(c) + ", ",
                                "DECOMPOSITION="+unicodedata.decomposition(c)+ ", ",
                                "NUMBER="+str(hex(ord(c))),
                                ")"
                                ))
            else:
                res = "".join( (res,
                                "{0:04X}".format(ord(c)),
                                ))

        # special case :
        except ValueError:
            res = "".join( (res,
                            "!UNKNOWN CHARACTER! : "+str(hex(ord(c)))
                            ))

        if not raw_number_only:
            # we add a semi-colon to separate the characters :
            res = "".join( (res,
                            "); ") )
        else:
            res = "".join( (res,
                            " ") )

    return res
